function H = homograf_lines(lL,lR)
%
% H = homograf_lines(lL,lR) vypocet homografie z primek
%
% H' * lL = g * lR
%

n = size(lL,1);

A = zeros(3*n,9);
for i = 1 : n
   A(i*3-2,:) = [-lR(i,3)*lL(i,:)  zeros(1,3)      lR(i,1)*lL(i,:)];
   A(i*3-1,:) = [ zeros(1,3)      -lR(i,3)*lL(i,:) lR(i,2)*lL(i,:)];
   A(i*3,:)   = [-lR(i,2)*lL(i,:)  lR(i,1)*lL(i,:) zeros(1,3)];
end;

[U,S,V] = svd(A);

disp(sprintf('Podminenost A = %f',S(1,1)/S(9,9)));

h = V(:,9);					% reseni soustavy Ah = 0

H = reshape(h,3,3);		% H

