function H = homograf_points(XL,XR)
%
% H = homograf_points(XL,XR) vypocet homografie z bodu
%
% a * XL = H * XR
%

n = size(XL,1);

A = zeros(2*n,9);
for i = 1 : n
   A(i*2-1,:) = [XR(i,:) zeros(1,3) -XL(i,1)*XR(i,:)];
   A(i*2,:)   = [zeros(1,3) XR(i,:) -XL(i,2)*XR(i,:)];
end;

[U,S,V] = svd(A);


s=sprintf('x(A) = %f',S(1,1)/S(9,9));
disp(s);

h = V(:,9);					% reseni soustavy Ah = 0

H = reshape(h,3,3)';		% H

% => nulujeme nejmensi singularni cislo
%[U,S,V] = svd(H);
%S(3,3) = 0;

% a zpetne slozime
%H = U*S*V';
