% Semestralni prace z PVI - uloha 1
% Panorama
% Vypocet homografie z bodu - normalizace dat
% Pavel Krizek, 5.4.2003

clear all;
close all;

% Nacteni korespondenci a obrazku
X = load_corr('km12.cor');
n = size(X,2);

U1 = [X(3:4,:)' ones(n,1)];
U2 = [X(1:2,:)' ones(n,1)];
IM1 = imread('KMsm02.jpg','jpg');
IM2 = imread('KMsm01.jpg','jpg');

[h,w,c] = size(IM1);

% Normalizace dat tak, aby mi = 0, sigma^2 = 1
[nU1,N1] = normalize(U1);
[nU2,N2] = normalize(U2);
iN1 = inv(N1);
iN2 = inv(N2);

% Vypocet homografie
nH = homograf_points(nU1,nU2);
inH = inv(nH);

H = iN1 * nH * N2;
iH = iN2 * inH * N1;

% Urceni velikosti vysledneho obrazu
dim = (H * [1,1,1; w,1,1; 1,h,1; w,h,1]')';
dim(:,1) = dim(:,1)./dim(:,3);
dim(:,2) = dim(:,2)./dim(:,3);
dim(:,3) = [];
dim = round(dim);

% Alokace pameti pro vysledny panoramaticky snimek
ww = max(dim(:,1));
w2_min = min(dim(:,1));
hh_min = min([dim(:,2);1]);
hh_max = max([dim(:,2);h]);
hh = hh_max-hh_min+1;

IM = uint8(zeros(hh,ww,3));

% Panorama - 2. snimek
A = ones(hh,ww-w2_min,3);
A(:,:,1) = ones(hh,1)*(w2_min+1:ww);            % x
A(:,:,2) = (hh_min:hh_max)'*ones(1,ww-w2_min);  % y
LUTi = reshape(A,hh*(ww-w2_min),3);             % hledane souradnice v IM

LUTo = (iH * LUTi')';

LUTo(:,1) = LUTo(:,1)./LUTo(:,3);
LUTo(:,2) = LUTo(:,2)./LUTo(:,3);
LUTo(:,3) = [];
  
LUT = reshape(LUTo, hh, ww-w2_min, 2);          % odpovidajici nalezene souradnice v IM2

% interpolace
IMG(:,:,1) = uint8(interp2(double(IM2(:,:,1)), LUT(:,:,1), LUT(:,:,2))); % R
IMG(:,:,2) = uint8(interp2(double(IM2(:,:,2)), LUT(:,:,1), LUT(:,:,2))); % G
IMG(:,:,3) = uint8(interp2(double(IM2(:,:,3)), LUT(:,:,1), LUT(:,:,2))); % B

IM(:,w2_min:ww-1,:) = IMG(:,:,:);

% Panorama - 1. snimek
IM(1-hh_min+1:h-hh_min+1,1:w,:) = IM1;

% Vykresleni vysledku
figure;
image(IM);
axis off;
axis equal;

%imwrite(IM, 'panorama1an.jpg','jpg');

% Vykresleni rozdiloveho snimku
IL = im2double(rgb2gray(IM1(:,w2_min+1:w,:)));
IR = im2double(rgb2gray(IMG(1-hh_min+1:h-hh_min+1,1:w-w2_min,:)));
idx = find(IR(:) == 0);
%IL(idx) = 0;
D_IM = 1 - abs(IL - IR);
D_IM(idx) = 0;

figure;
imagesc(D_IM), colormap gray(256);
axis off;
axis equal;

%imwrite(im2uint8(D_IM), 'ratio1an.jpg','jpg');
