% Semestralni prace z PVI - uloha 1
% Panorama
% Vypocet homografie z primek - normalizace dat
% Pavel Krizek, 7.4.2003

clear all;
close all;

% Nacteni obrazku
IM1 = imread('KMsm02.jpg','jpg');
IM2 = imread('KMsm01.jpg','jpg');
[h,w,c] = size(IM1);

% Nacteni korespondenci a normalizace dat
load_lines;

l1 = cross(u1, v1);
l1 = l1 ./ (l1(:,3)*ones(1,3));
[nl1,N1] = normalize(l1);
iN1 = inv(N1);

l2 = cross(u2, v2);
l2 = l2 ./ (l2(:,3)*ones(1,3));
[nl2,N2] = normalize(l2);
iN2 = inv(N2);

% Vypocet homografie
nH = homograf_lines(nl1,nl2);

H = (iN2 * nH' * N1)';
iH = inv(H);

% Urceni velikosti vysledneho obrazu
dim = (H * [1,1,1; w,1,1; 1,h,1; w,h,1]')';
dim(:,1) = dim(:,1)./dim(:,3);
dim(:,2) = dim(:,2)./dim(:,3);
dim(:,3) = [];
dim = round(dim);

% Alokace pameti pro vysledny panoramaticky snimek
ww = max(dim(:,1));
w2_min = min(dim(:,1));
hh_min = min(dim(:,2));
hh_max = max(dim(:,2));
hh = hh_max-hh_min+1;

IM = uint8(zeros(hh,ww,3));

% Panorama - 2. snimek
A = ones(hh,ww-w2_min,3);
A(:,:,1) = ones(hh,1)*(w2_min+1:ww);            % x
A(:,:,2) = (hh_min:hh_max)'*ones(1,ww-w2_min);  % y
LUTi = reshape(A,hh*(ww-w2_min),3);             % hledane souradnice v IM

LUTo = (iH * LUTi')';

LUTo(:,1) = LUTo(:,1)./LUTo(:,3);
LUTo(:,2) = LUTo(:,2)./LUTo(:,3);
LUTo(:,3) = [];
  
LUT = reshape(LUTo, hh, ww-w2_min, 2);          % odpovidajici nalezene souradnice v IM2

% interpolace
IMG(:,:,1) = uint8(interp2(double(IM2(:,:,1)), LUT(:,:,1), LUT(:,:,2))); % R
IMG(:,:,2) = uint8(interp2(double(IM2(:,:,2)), LUT(:,:,1), LUT(:,:,2))); % G
IMG(:,:,3) = uint8(interp2(double(IM2(:,:,3)), LUT(:,:,1), LUT(:,:,2))); % B

IM(:,w2_min:ww-1,:) = IMG(:,:,:);

% Panorama - 1. snimek
IM(1-hh_min+2:h-hh_min+2,1:w,:) = IM1;

% Vykresleni vysledku
figure;
image(IM);
axis off;
axis equal;

%imwrite(IM, 'panorama1bn.jpg','jpg');

% Vykresleni rozdiloveho snimku
IL = im2double(rgb2gray(IM1(:,w2_min+1:w,:)));
IR = im2double(rgb2gray(IMG(1-hh_min+1:h-hh_min+1,1:w-w2_min,:)));
idx = find(IR(:) == 0);
%IL(idx) = 0;
D_IM = 1 - abs(IL - IR);
D_IM(idx) = 0;

figure;
imagesc(D_IM), colormap gray(256);
axis off;
axis equal;

%imwrite( im2uint8(D_IM), 'ratio1bn.jpg','jpg');

